/* 
   DOCoder.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: DOCoder.h,v 1.3 1998/10/06 08:52:58 helge Exp $

#import <NGStreams/NGStreamCoder.h>

@class NGConnection;

@interface DOCoder : NGStreamCoder
{
  NGConnection *connection; // not retained
  BOOL         isRequest;
}

+ (id)coderWithStream:(id<NGSerializer,NGStream>)_stream
  connection:(NGConnection *)_c;
- (id)initWithStream:(id<NGSerializer,NGStream>)_stream
  connection:(NGConnection *)_c;

// accessors

- (NGConnection *)connection;

// copy state

- (BOOL)isBycopy; // encode object
- (BOOL)isByref;  // vend proxy

// references

- (void)invalidate; // called when the connection is deallocated

// operations

- (void)encodeObject:(id<NSObject>)_object bycopy:(BOOL)_flag;
- (void)encodeValueOfObjCType:(const char *)_type at:(void *)_value
  bycopy:(BOOL)_flag;

// invocations

- (BOOL)isInvocationInMode;
- (void)encodeInvocation:(NSInvocation *)_invocation;
- (void)encodeInvocationResult:(NSInvocation *)_invocation;

@end

@interface NSObject(DOCoder)

- (Class)classForDOCoder:(DOCoder *)_coder;          // default: classForCoder:
- (id)replacementObjectForDOCoder:(DOCoder *)_coder; // returns proxy

@end
