/* 
   DOProtocol.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: DOProtocol.h,v 1.3 1998/10/08 18:42:36 helge Exp $

#import <NGStreams/NGStreamProtocols.h>

@class DOCoder;
@class NSInvocation;

#define REPLY 128
#define VALUE 127

typedef enum {
  DOMsg_ROOT      = 1, // get root object
  DOMsg_HELLO     = 2, // say hello
  DOMsg_SIGNATURE = 3, // get signature for selector
  DOMsg_RELEASE   = 4, // unvend object (proxy was deallocated)
  DOMsg_INVOKE    = 5, // invoke message
  DOMsg_HASCLASS  = 6, // class found
  DOMsg_THROW     = 7, // throw a exception
  DOMsg_SHUTDOWN  = 8, // shutdown connection
} DOMessageCode;

unsigned DOSendRequestHead(id<NGSerializer> _destination, DOMessageCode _code);
void DOSendReplyHead(id<NGSerializer> _src, DOMessageCode _code, unsigned _serial);

DOMessageCode DOReceiveHead(id<NGSerializer> _src, unsigned *serial_);


char *DOGetSignature(id<NGSerializer> _send, id<NGSerializer> _rcv,
                     SEL _selector, unsigned _remoteId);

/*
void DOMarshallInvocation(NSInvocation *self, NSMethodSignature *sig,
                          unsigned _target,
                          DOCoder *_encoder, id<NGSerializer> _destination);

NSInvocation *DOUnmarshallInvocation(DOCoder *_decoder, id<NGSerializer> _source);
*/

