/* 
   NGConnection.m

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGConnection.m,v 1.3 1998/10/06 08:53:00 helge Exp $

#import "common.h"
#import "NGConnection.h"
#import "NGActiveConnection.h"
#import "NGPassiveConnection.h"

@implementation NGConnection

#if !LIB_FOUNDATION_BOEHM_GC
- (void)dealloc {
  RELEASE(self->rootObject); self->rootObject = nil;
  [super dealloc];
}
#endif

// passive connections

+ (NGConnection *)defaultConnection {
  return [NGPassiveConnection defaultConnection];
}

// active connections

+ (NGConnection *)connectionWithRegisteredAddress:(id<NGSocketAddress>)_address {
  return [NGActiveConnection connectionWithRegisteredAddress:_address];
}
+ (NGDistantObject *)rootProxyForConnectionWithAddress:(id<NGSocketAddress>)_addr {
  return [[self connectionWithRegisteredAddress:_addr] rootProxy];
}

// accessors

- (void)setRootObject:(id<NSObject>)_root {
  ASSIGN(self->rootObject, _root);
}
- (id<NSObject>)rootObject {
  return self->rootObject;
}

// active connection only

- (NGDistantObject *)rootProxy {
  return [self subclassResponsibility:_cmd];
}

// passive connection only

- (BOOL)registerAddress:(id<NGSocketAddress>)_address {
  return (int)[self subclassResponsibility:_cmd];
}

// description

- (NSString *)description {
  NSMutableString *string = [NSMutableString stringWithCapacity:128];

  [string appendFormat:@"<Connection[0x%08X]", (unsigned)self];
  [string appendString:@">"];

  return string;
}

@end
