// $Id: NGBase64Coding.h,v 1.3 1998/10/10 14:38:33 helge Exp $

#import <Foundation/NSString.h>
#import <Foundation/NSData.h>

/*
  Base64 encoder/decoder

  Attention: these methods/function do _not_ generate a '\n' at the end of
             the end of encoding (after the '=' signs).

  The NSString and NSData have their own maximum line length, for strings
  it is currently 1024 bytes and for data's 72 chars.
*/

@interface NSString(Base64Coding)

- (NSString *)stringByEncodingBase64;
- (NSString *)stringByDecodingBase64;

@end

@interface NSData(Base64Coding)

- (NSData *)dataByEncodingBase64;
- (NSData *)dataByDecodingBase64;

@end

/*
  These function return the length of the resulting buffer or -1 on error
*/
int NGEncodeBase64(const void *_source, unsigned _len,
                   void *_buffer, unsigned _bufferCapacity,
                   int _maxLineWidth);
int NGDecodeBase64(const void *_source, unsigned _len,
                   void *_buffer, unsigned _bufferCapacity);
