/* 
   NGExtensions.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGExtensions.h,v 1.26 1999/03/26 12:42:41 helge Exp $

#ifndef __NGExtensions_H__
#define __NGExtensions_H__

#if defined(__MINGW32__)
#  define OPENSTEP 0
#  define GNUSTEP  1
#elif defined(NeXT) || defined(WIN32)
#  define OPENSTEP 1
#  define GNUSTEP  0
#  ifndef NeXT_RUNTIME
#    define NeXT_RUNTIME 1
#  endif
#else
#  define OPENSTEP 0
#  define GNUSTEP  1
#endif

#if OPENSTEP
#  import <FoundationExtensions/objc-api.h>
#  import <FoundationExtensions/objc-runtime.h>
#  import <FoundationExtensions/NSException.h>
#  import <FoundationExtensions/GeneralExceptions.h>
#  import <FoundationExtensions/MissingMethods.h>
#endif

#if defined(LIB_FOUNDATION_LIBRARY)
#  define NoZone nil
#else
#  define NoZone NULL
#endif

#ifndef RETAIN
#define RETAIN(_obj_) [_obj_ retain]
#endif
#ifndef RELEASE
#define RELEASE(_obj_) [_obj_ release]
#endif
#ifndef AUTORELEASE
#define AUTORELEASE(_obj_) [_obj_ autorelease]
#endif
#ifndef ASSIGN
#define ASSIGN(_left_, _right_) \
  if (_left_ != _right_) { \
     [_left_ release]; \
     _left_ = [_right_ retain];\
  }
#endif

#import <NGExtensions/NGBase64Coding.h>
#import <NGExtensions/NGBaseTypes.h>
#import <NGExtensions/NGBitSet.h>
#import <NGExtensions/NGCString.h>
#import <NGExtensions/NGHashMap.h>
#import <NGExtensions/NGMD5Generator.h>
#import <NGExtensions/NGMainMacros.h>
#import <NGExtensions/NGMemoryAllocation.h>
#import <NGExtensions/NGNil.h>
#import <NGExtensions/NGProxy.h>
#import <NGExtensions/NGStack.h>
#import <NGExtensions/NGTool.h>
#import <NGExtensions/NSArray+enumerator.h>
#import <NGExtensions/NSData+misc.h>
#import <NGExtensions/NSException+misc.h>
#import <NGExtensions/NSMethodSignature+misc.h>
#import <NGExtensions/NSObject+Values.h>
#import <NGExtensions/NSSet+enumerator.h>
#import <NGExtensions/NSString+Formatting.h>
#import <NGExtensions/NSString+misc.h>
#import <NGExtensions/NSDictionary+misc.h>
#import <NGExtensions/NSCalendarDate+misc.h>

#import <NGExtensions/NGArchiver.h>

#if defined(WIN32)

static inline const char *index(register const char *_str, register unsigned char _c) {
  if (_str == NULL) return NULL;
  while ((*_str != '\0') && (*_str != _c)) _str++;
  if (*_str == _c) return _str;
  return NULL;
}

#endif

#if !OPENSTEP
#  import <NGExtensions/NSAttributedString.h>
//#  import <NGExtensions/NGPropertyListParser.h>
#endif

// kit class

@interface NGExtensions : NSObject
@end

// linking ..

#define LINK_NGExtensions \
  void __link_NGExtensions(void) { \
    [NGExtensions self];   \
    __link_NGExtensions(); \
  }

#endif /* __NGExtensions_H__ */
