/* 
   NGMainMacros.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGMainMacros.h,v 1.2 1998/10/02 10:15:06 helge Exp $

#import <NGExtensions/NGTool.h>

static inline int _tool_main(int _ac, char **_av, char **env,
                             NGToolFunction _func, NGOptionDescription *_options) {
  NGTool *tool = nil;
  tool = [[NGTool alloc] initWithArguments:_av count:_ac environment:env];
  {
    [tool setToolFunction:_func];
    if (_options)
      [tool parseOptions:_options];
    [tool run];
  }
  [tool release];
  tool = nil; 
  return 0;
}

#define NGMain \
  static NGOptionDescription *_tool_main_opts = NULL; \
  static void tool_main(NGTool *tool, NSArray *args, int argc, char **argv) {

#define NGMainOpt(_ToolOpts_) \
  static NGOptionDescription *_tool_main_opts = _ToolOpts_; \
  static void tool_main(NGTool *tool, NSArray *args, int argc, char **argv) {

#define NGEndMain \
  } \
  int main(int _ac, char **_av, char **env) \
  { return _tool_main(_ac, _av, env, tool_main, _tool_main_opts); }
