/* 
   NGProxy.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGProxy.h,v 1.4 1998/10/15 17:18:44 helge Exp $

#if defined(NeXT) || defined(WIN32)

#import <Foundation/NSProxy.h>

@interface NGProxy : NSProxy
{
}
@end

#else /* ! NeXT */

#include <objc/objc.h>
#import <Foundation/NSObject.h>

@class NSInvocation, NSMethodSignature, NSString;

@interface NGProxy < NSObject >
{
  Class isa; // NGProxy or subclass
}

// allocation

+ (id)alloc;
+ (id)allocWithZone:(NSZone *)_zone;
- (void)dealloc;

- (id)autorelease;
+ (id)autorelease;
- (void)release;
+ (void)release;
- (id)retain;
+ (id)retain;
- (unsigned int)retainCount;
+ (unsigned int)retainCount;
- (NSZone *)zone;

// reflection & forwarding

- (BOOL)isProxy; // returns YES

- (void)forwardInvocation:(NSInvocation *)_invocation;
- (NSMethodSignature *)methodSignatureForSelector:(SEL)_selector;

// description

//- (NSString *)description;

// NSObject protocol (abstract methods)

- (Class)class;
- (Class)superclass;

- (BOOL)isKindOfClass:(Class)_class;
- (BOOL)isMemberOfClass:(Class)_class;
- (BOOL)conformsToProtocol:(Protocol *)_protocol;

- (BOOL)respondsToSelector:(SEL)_selector;

- (unsigned)hash;
- (BOOL)isEqual:(id)_anObject;
- (id)self;

- (id)performSelector:(SEL)_selector;
- (id)performSelector:(SEL)_selector withObject:(id)_object;
- (id)performSelector:(SEL)_selector withObject:(id)_obj1 withObject:(id)_obj2;

@end

#endif /* ! NeXT */
