/* 
   NSConcreteAttributedString.h

   Copyright (C) 1998 MDlink online service center
   All rights reserved.

   Author: Jan Reichmann <jan@mdlink.de>

   This file is part of libFoundation.

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NSConcreteAttributedString.h,v 1.3 1998/10/06 08:43:32 helge Exp $

#import <NGExtensions/NSAttributedString.h>
#import <NGExtensions/NSAttributedStringTypeDefinitions.h>

@protocol _NSShortAttributedString < NSObject >

- (id)__initWithShortStringStruc:(NSShortAttributedString *)_string;
- (NSShortAttributedString *)__shortStringStruct;

@end

@interface _NSConcreteShortAttributedString : NSAttributedString
                                              <_NSShortAttributedString>
{
@private
  NSShortAttributedString *attributedString;
}
@end

@interface _NSConcreteShortMutableAttributedString : NSMutableAttributedString
                                                     <_NSShortAttributedString>
{
@private
  NSShortAttributedString *attributedString;
}

@end

/*
  Local Variables:
  c-basic-offset: 4
  tab-width: 8
  End:
*/
