/* 
   NSException+misc.m

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NSException+misc.m,v 1.4 1998/10/11 04:37:11 helge Exp $

#import "common.h"
#import "NSException+misc.h"

@implementation NSException(NGMiscellaneous)

- (id)initWithReason:(NSString *)_reason {
  return [self initWithReason:_reason userInfo:nil];
}
- (id)initWithReason:(NSString *)_reason userInfo:(id)_userInfo {
  return [self initWithName:NSStringFromClass([self class])
               reason:_reason
               userInfo:_userInfo];
}

- (id)initWithFormat:(NSString *)_format,... {
  NSString *tmp = nil;
  va_list  ap;
  
  va_start(ap, _format);
  tmp = [[NSString allocWithZone:[self zone]]
                   initWithFormat:_format arguments:ap];
  va_end(ap);

  self = [self initWithReason:tmp userInfo:nil];
  RELEASE(tmp); tmp = nil;
  return self;
}

@end

void __link_NGExtensions_NSExceptionMisc() {
  __link_NGExtensions_NSExceptionMisc();
}
