/* 
   common.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: common.h,v 1.15 1999/03/16 13:36:36 helge Exp $

#ifndef __NGExtensions_common_h__
#define __NGExtensions_common_h__

#import <Foundation/Foundation.h>
#import <Foundation/NSMapTable.h>

#if defined(WIN32)
#  include <windows.h>
#elif defined(NeXT)
#  include <netinet/in.h>
#else
#  include <arpa/inet.h>
#endif

#if !defined(WIN32)
#include <unistd.h>
#endif

#if defined(__MINGW32__)
#  define OPENSTEP 0
#  define GNUSTEP  1
#elif defined(NeXT) || defined(WIN32)
#  define OPENSTEP 1
#  define GNUSTEP  0
#  ifndef NeXT_RUNTIME
#    define NeXT_RUNTIME 1
#  endif
#else
#  define OPENSTEP 0
#  define GNUSTEP  1
#endif

#if OPENSTEP
#  import <FoundationExtensions/objc-api.h>
#  import <FoundationExtensions/objc-runtime.h>
#  import <FoundationExtensions/NSException.h>
#  import <FoundationExtensions/GeneralExceptions.h>
#  import <FoundationExtensions/MissingMethods.h>
#else
#  include <time.h>
#  import <objc/objc-api.h>
#  import <objc/objc.h>
#  import <objc/encoding.h>
#  import <extensions/objc-runtime.h>
#  import <Foundation/exceptions/StringExceptions.h>
#  import <Foundation/exceptions/GeneralExceptions.h>
#endif

#if defined(LIB_FOUNDATION_LIBRARY)
#  define NoZone nil
#else
#  define NoZone NULL
#endif

#include <ctype.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef __MINGW32__
#include <strings.h>
#endif

#if defined(WIN32)
static inline const char *index(const char *str, char c) __attribute__((unused));

static const char *index(const char *str, char c) {
  while ((*str != '\0') && (*str != c)) str++;
  if (*str == '\0') return NULL;
  else return str;
}
#endif

#ifndef RETAIN
#  define RETAIN(_obj_) [_obj_ retain]
#endif
#ifndef RELEASE
#  define RELEASE(_obj_) [_obj_ release]
#endif
#ifndef AUTORELEASE
#  define AUTORELEASE(_obj_) [_obj_ autorelease]
#endif

#ifndef ASSIGN
#define ASSIGN(_left_, _right_) \
  if (_left_ != _right_) { \
     [_left_ release]; \
     _left_ = [_right_ retain];\
  }
#endif

#endif
