/* 
   NGLocalSocketDomain.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGLocalSocketDomain.h,v 1.5 1999/01/27 15:26:32 helge Exp $

#ifndef __NGNet_NGLocalSocketDomain_H__
#define __NGNet_NGLocalSocketDomain_H__

#if !defined(WIN32)
// UNIX domain, not available on WIN32

#import <Foundation/NSObject.h>
#include <NGNet/NGSocketProtocols.h>

/*
  Represents the AF_LOCAL (AF_UNIX) socket domain.

  NGLocalSocketDomain is a singleton, therefore on copy it returns itself and on
  unarchiving it replaces the unarchived instance with the singleton.
*/

@interface NGLocalSocketDomain : NSObject < NSCopying, NSCoding, NGSocketDomain >

+ (id)domain;

// NGSocketDomain

- (id<NGSocketAddress>)addressWithRepresentation:(void *)_data
  size:(unsigned int)_size;

- (int)socketDomain;
- (int)protocol;

@end

#define NGDefaultLocalSocketDomain [NGLocalSocketDomain domain]

#endif /* !WIN32 */

#endif /* __NGNet_NGLocalSocketDomain_H__ */
