/* 
   NGNet.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGNet.h,v 1.8 1999/01/27 15:26:32 helge Exp $

#ifndef __NGNet_H__
#define __NGNet_H__

#include <NGNet/NGActiveSocket.h>
#include <NGNet/NGInternetSocketAddress.h>
#include <NGNet/NGInternetSocketDomain.h>
#include <NGNet/NGPassiveSocket.h>
#include <NGNet/NGSocket.h>
#include <NGNet/NGSocketExceptions.h>
#include <NGNet/NGSocketProtocols.h>
#include <NGNet/NGDatagramPacket.h>
#include <NGNet/NGDatagramSocket.h>
#include <NGNet/NGActiveSocket+serialization.h>
#include <NGNet/NGNetUtilities.h>

#if !defined(WIN32)
#include <NGNet/NGLocalSocketAddress.h>
#include <NGNet/NGLocalSocketDomain.h>
#endif

extern void __link_NGActiveSocket_serialization(void);

#if defined(WIN32)
static inline void __link_NGNet_platform(void) {
}
#else
static inline void __link_NGNet_platform(void) {
  [NGLocalSocketAddress class];
  [NGLocalSocketDomain  class];
}
#endif

#define LINK_NGNet \
  void __link_NGNet() { \
    ; \
    [NGActiveSocket          self]; \
    [NGInternetSocketAddress self]; \
    [NGInternetSocketDomain  self]; \
    [NGPassiveSocket         self]; \
    [NGSocket                self]; \
    [NGDatagramPacket        self]; \
    [NGDatagramSocket        self]; \
    \
    __link_NGActiveSocket_serialization(); \
    __link_NGNet_platform(); \
    __link_NGNet(); \
  }

#endif /* __NGNet_H__ */
