/* 
   NGNetUtilities.h

   Copyright (C) 1999 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGNetUtilities.h,v 1.2 1999/01/27 15:26:32 helge Exp $

#ifndef __NGNet_NGNetUtilities_H__
#define __NGNet_NGNetUtilities_H__

#import <Foundation/NSObject.h>
#include <NGNet/NGSocketProtocols.h>

/*
  Some supporting functions
*/

/*
  This function tried to 'guess' the appropriate socket address from _string.
  It currently creates an internet domain address if a ':' is encountered and
  a local domain address if the string returns true on -isAbsolutePath.
  The function returns nil if the string argument is nil or empty.

  Examples are:

    INET:   "*:20000"           // wildcard IP, port 20000
            "localhost:1000"    // localhost, port 1000
            "*:echo/udp"        // wildcard IP, echo service on UDP
            "*:echo"            // wildcard IP, echo service on TCP (TCP=default)
            
    LOCAL:  "/tmp/mySocket"
*/
id<NGSocketAddress> NGSocketAddressFromString(NSString *_string);

#endif /* __NGNet_NGNetUtilities_H__ */
