/* 
   common.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: common.h,v 1.6 1999/01/29 14:27:26 helge Exp $

// common include files & definitions

#ifndef __NGNet_common_H__
#define __NGNet_common_H__

#include "config.h"

#ifdef HAVE_WINDOWS_H
#  include <windows.h>
#endif
#ifdef HAVE_WINSOCK_H
#  include <winsock.h>
#endif

#if !defined(SHUT_RD)
#  define SHUT_RD   0
#endif
#if !defined(SHUT_WR)
#  define SHUT_WR   1
#endif
#if !defined(SHUT_RDWR)
#  define SHUT_RDWR 2
#endif

#ifdef HAVE_STRING_H
#  include <string.h>
#endif
#ifdef HAVE_STRINGS_H
#  include <strings.h>
#endif

#ifndef WIN32
#  include <arpa/inet.h>
#endif

#ifdef HAVE_SYS_SOCKET_H
#  include <sys/socket.h>
#endif
#ifdef HAVE_NETDB_H
#  include <netdb.h>
#endif

#ifndef AF_LOCAL
#  define AF_LOCAL AF_UNIX
#endif

#import <Foundation/Foundation.h>
#import <Foundation/NSHost.h>
#import <NGExtensions/NGExtensions.h>
#include <NGStreams/NGStreams.h>

#endif /* __NGNet_common_H__ */
