/* 
   NGBase64Stream.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGBase64Stream.h,v 1.10 1999/01/27 16:11:14 helge Exp $

#ifndef __NGStreams_NGBase64Stream_H__
#define __NGStreams_NGBase64Stream_H__

#include <NGStreams/NGFilterStream.h>

@interface NGBase64Stream : NGFilterStream
{
@protected
  // decoding
  char decBuffer[3]; // output buffer
  char decBufferLen; // number of bytes in buffer

  // encoding
  int  buf;          // a 24-bit quantity
  int  bufBytes;     // how many octets are set in it
  char line[74];     // output buffer
  char lineLength;   // output buffer fill pointer
}

- (unsigned)readBytes:(void *)_buf count:(unsigned)_len; // decoder
- (unsigned)writeBytes:(const void *)_buf count:(unsigned)_len; // encoder

- (void)close;
- (void)flush;

@end

#endif /* __NGStreams_NGBase64Stream_H__ */
