/* 
   NGByteCountStream.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGByteCountStream.h,v 1.4 1999/01/27 16:11:15 helge Exp $

#ifndef __NGStreams_NGByteCountStream_H__
#define __NGStreams_NGByteCountStream_H__

#include <NGStreams/NGFilterStream.h>

@interface NGByteCountStream : NGFilterStream
{
@protected
  unsigned      totalReadCount;
  unsigned      totalWriteCount;
  unsigned char byteToCount;
  unsigned      byteReadCount;
  unsigned      byteWriteCount;
}

+ (id)byteCounterForStream:(id<NGStream>)_stream byte:(unsigned char)_byte;
- (id)initWithSource:(id<NGStream>)_source byte:(unsigned char)_byte;

// accessors

- (void)setByteToCount:(unsigned char)_byte;
- (unsigned char)byteToCount;

- (unsigned)readCount;
- (unsigned)writeCount;

- (unsigned)totalReadCount;
- (unsigned)totalWriteCount;

// operations

- (void)resetCounters;

@end

#endif /* __NGStreams_NGByteCountStream_H__ */
