/* 
   NGHttpUrl.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id$

#ifndef __NGStreams_NGHttpUrl_H__
#define __NGStreams_NGHttpUrl_H__

#include <NGStreams/NGUrl.h>

/*
  HTTP Urls:

    httpaddress : 'http://' hostport { '/' path } { '?' search }
    hostport    : hostname { ':' port }
    hostname    : alpha ( xalpha )*
    port        : ( digit )+
    path        : void | (xpalpha)+ { '/' path }
    search      : ( xalpha )+ { '+' search }
    xalpha      : alpha | digit | safe | extra | escape
    xpalpha     : xalpha | +

  Description:
  
    Xpalpha are chars that can occure in a path. Notably this includes the
    '+' char which has a different meaning the search part, where the plus
    separated the search components.

  Examples:

    http://www.mdlink.de/search.cgi?hallo=23&
*/

@interface NGHttpUrl : NGUrl
{
@protected
  NSString *host;
  int      port;
}

@end

#endif /* __NGStreams_NGHttpUrl_H__ */
