/* 
   NGTaskStream.m

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGTaskStream.m,v 1.2 1999/01/27 16:41:18 helge Exp $

#include "config.h"
#include "common.h"
#include "NGTaskStream.m"

@implementation NGTaskStream

- (id)initWithPath:(NSString *)_executable
  arguments:(NSArray *)_args
  environment:(NSDictionary *)_env
{
  return nil;
}

- (void)dealloc {
  [super dealloc];
}

// state

- (BOOL)isOpen {
  return [self->task isRunning];
}

// primitives

- (unsigned)readBytes:(void *)_buf count:(unsigned)_len {
}
- (unsigned)writeBytes:(const void *)_buf count:(unsigned)_len {
}

- (void)close {
  if (![self isOpen]) {
    NSLog(@"tried to close already closed stream %@", self);
    return;
  }
  [self->task terminate];
}

- (NGStreamMode)mode {
  return NGStreamMode_readWrite;
}
- (BOOL)isRootStream {
  return YES;
}

// marking

- (void)mark {
  NSLog(@"WARNING: called mark on a stream which doesn't support marking !");
}
- (void)rewind {
  THROW([[NGStreamException alloc] initWithStream:self
                                   reason:@"marking not supported"]);
}
- (BOOL)markSupported {
  return -1;
}

// description

- (NSString *)description {
  return [NSString stringWithFormat:
                     @"<%@[0x%08X] task=%@ mode=%@>",
                     NSStringFromClass([self class]), (unsigned)self,
                     self->task,
                     [self modeDescription]];
}

@end
