/* 
   coder.m

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: task.m,v 1.2 1998/12/30 09:49:27 helge Exp $

#import "common.h"

NGOptionDescription options[] = {
  { @"-?",   @"--help",     NGHelpOption,     0, NULL, @"show help page" },
  NGLogOption,
  NGLastOption
};

NGMainOpt(options) {
  NGInitTextStdio();
  [NSAutoreleasePool enableDoubleReleaseCheck:NO];

  {
    NSTask       *task = [[NSTask alloc] init];
    NGStreamPipe *pin  = [NGStreamPipe pipe];
    NGStreamPipe *pout = [NGStreamPipe pipe];
    NGTextStream *in   = [NGCTextStream textStreamWithSource:pin];
    NGTextStream *out  = [NGCTextStream textStreamWithSource:pout];

    [task setLaunchPath:@"/bin/bc"];
    //[task setArguments:[NSArray arrayWithObject:@"/doofdoof"]];
    [task setStandardInput:pin];
    [task setStandardOutput:pout];
    [task setStandardError:pout];

    NSLog(@"in=%@ out=%@", pin, pout);
    
    NSLog(@"launched task %@ ..", task);
    [task launch];
    NSLog(@"launched task %@ ..", task);

    NSLog(@"in=%@ out=%@", pin, pout);
    
    do {
      NSString *line = nil;

      if (![task isRunning]) {
        NSLog(@"task isn't running: %@", task);
        break;
      }
      
      [NGTextOut writeString:@"Enter expression: "];
      [NGTextOut flush];
      line = [NGTextIn readLineAsString];
      if (line == nil) break;

      if ([line isEqualToString:@"quit"]) break;

      if (![task isRunning]) {
        NSLog(@"task isn't running: %@", task);
        break;
      }

      [NGTextOut writeFormat:@"send: %@\n", line];
      [in writeString:line];
      [in writeNewline];
      [in flush];
      
      //NSLog(@"task: %@.", task);
      line = [out readLineAsString];
      if (line == nil) break;
      [NGTextOut writeFormat:@"recv: %@\n", line];
    }
    while (1);
  }
}
NGEndMain;

LINK_NGExtensions;
LINK_NGStreams;
