/* 
   md5.m

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: md5.m,v 1.3 1998/10/07 18:42:01 helge Exp $

#import "common.h"

NGOptionDescription options[] = {
  { @"-s",   @"--string", NGRegisterOption, 1, "s",  @"string to encode" },
  { @"-f",   @"--file",   NGRegisterOption, 1, "s",  @"file to encode" },
  { @"-?",   @"--help",   NGHelpOption,     0, NULL, @"show help page" },
  NGLogOption,
  NGLastOption
};

NGMainOpt(options) {
  NGInitTextStdio();

  if ([tool isOptionSet:@"-s"]) {
    NSString *value = [tool valueOfOption:@"-s"];

    [NGTextOut writeString:NGMD5DigestForString(value)];
    [NGTextOut writeNewline];
    [NGTextOut flush];
  }
  if ([tool isOptionSet:@"-f"]) {
    NSData   *data   = [NSData dataWithContentsOfFile:[tool valueOfOption:@"-f"]];

    if (data) {
      [NGTextOut writeString:NGMD5DigestForData(data)];
      [NGTextOut writeNewline];
      [NGTextOut flush];
    }
    else {
      [NGTextErr writeFormat:@"md5: could not read file %@\n",
                   [tool valueOfOption:@"-f"]];
      [NGTextErr flush];

      [tool exitWithCode:20];
    }
  }
}
NGEndMain;

LINK_NGExtensions;
LINK_NGStreams;
