/* 
   common.h

   Copyright (C) 1995, 1996, 1997 Ovidiu Predescu and Mircea Oancea.
   All rights reserved.

   Author: Ovidiu Predescu <ovidiu@bx.logicnet.ro>
           Mircea Oancea <mircea@jupiter.elcom.pub.ro>

   This file is part of the Foundation Extensions Library.

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/

#ifndef __common_h__
#define __common_h__

#include <string.h>
#include <memory.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/types.h>

#ifndef __WIN32__
#include <libc.h>
#include <pwd.h>
#endif

/* Define if the __builtin_apply pseudo-function doesn't set the floating
   point return value at retframe + 8 on Intel machines. */
/* #undef BROKEN_BUILTIN_APPLY */

char *strchr(), *strrchr();

#import <Foundation/NSZone.h>
#include "MissingMethods.h"

@class NSString;

static inline int Atoi(const char* str)
{
    return str ? atoi(str) : 0;
}

static inline long Atol(const char *str)
{
    return str ? atol(str) : 0;
}

#ifndef MAX
#define MAX(a, b) \
    ({typedef _ta = (a), _tb = (b);   \
	_ta _a = (a); _tb _b = (b);     \
	_a > _b ? _a : _b; })
#endif

#ifndef MIN
#define MIN(a, b) \
    ({typedef _ta = (a), _tb = (b);   \
	_ta _a = (a); _tb _b = (b);     \
	_a < _b ? _a : _b; })
#endif /* LIB_FOUNDATION_LIBRARY */

#endif /* __common_h__ */
