
#import <Foundation/Foundation.h>
#import <FoundationExtensions/NSException.h>

#if defined(WIN32)
#include <windows.h>

static void testWinIO(const char *filename) {
  HANDLE fh;

  fh = CreateFile(filename,
		  GENERIC_READ,
		  FILE_SHARE_READ,
		  NULL,
		  OPEN_EXISTING,
		  0,
		  NULL);
  if (fh != INVALID_HANDLE_VALUE) {
    DWORD fileSize = GetFileSize(fh, NULL);
    NSLog(@"file %s is %i bytes big ..", filename, fileSize);
    if (fileSize > 0) {
      char  *buffer   = malloc(fileSize + 1);
      DWORD readBytes = 0;
      buffer[fileSize] = '\0';

      if (ReadFile(fh, buffer, fileSize, &readBytes, NULL)) {
        NSLog(@"read %i bytes ..", readBytes);
        NSLog(@"Text is:\n%s\n", buffer);
      }
    }
    CloseHandle(fh);
  }
  else {
    NSLog(@"could not open file: %s.", filename);
  }
}
#endif

@interface MyExcClass : NSException
@end

@implementation MyExcClass
@end

int main (int argc, const char *argv[])
{
   NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
#if defined(WIN32)
    testWinIO("C:\\xstart.log");
#endif
    {
      NSLog(@"Hello World !");

      TRY {
        THROW([[MyExcClass alloc] initWithName:@"doof"
                                  reason:@"hello"
                                  userInfo:nil]);
      } END_TRY;
      CATCH (MyExcClass) {
        NSLog(@"CATCH catched %@", localException);
      }
      OTHERWISE {
        NSLog(@"otherwise ..");
      }
      END_CATCH;
    }
   [pool release];
   exit(0);       // insure the process exit status is 0
   return 0;      // ...and make main fit the ANSI spec.
}
